(
s.waitForBoot ({
	{
		~bufferPointer = 0;

		s.sync;
		~soundsPath = PathName.new("sounds/".resolveRelative);
		~soundsPath.filesDo({|path| path.fileNameWithoutExtension.postln });
		~sounds = SoundFile.collectIntoBuffers(~soundsPath.pathOnly ++ "*" );   //Load Sounds

		Buffer.alloc(s, 2048, 1); //Buffer allocation for PV_Morph
		Buffer.alloc(s, 2048, 1);
		Buffer.alloc(s, 2048, 1);
		Buffer.alloc(s, 2048, 1);


		SynthDef("inst", // Synth with 4 granular processors
			{   |outLeft = 0, outRight = 1, rate = 1.0, bRate = 1.0, bufNum = 0, bBufNum = 1, bufNum2 = 2, bBufNum2 = 3,
				rateDev = 0.0, bRateDev = 0.0, density = 1, bDensity = 1, durGrain = 0.5, bDurGrain = 0.5, durDev = 0.01,
				xMorph = 0.5, yMorph = 0.5, inpol = 2, paner = 0.5, amp1 = 0.6, amp2 = 0.6, amp3 = 0.6, amp4 = 0.6|

				var xfade, fft_A, fft_B, fft_A1, fft_B2, morph, b_morph, grains, grains_1, b_grains, b_grains2;

				var grainLen = durGrain * rate;
				var center = WhiteNoise.ar(0.5, 0.5).madd(BufDur.kr(bufNum) - grainLen, grainLen * 0.5);

				grains = TGrains.ar(2, Dust.ar(density), //grains 1
					bufNum,
					WhiteNoise.ar(rateDev,rate),
					center,
					WhiteNoise.ar(durDev, durGrain), interp:inpol,
					pan:WhiteNoise.kr(paner),
					amp:amp1
				);

				b_grains = TGrains.ar(2, Dust.ar(bDensity), //grains 2
					bBufNum,
					WhiteNoise.ar(bRateDev,bRate),
					center,
					WhiteNoise.ar(durDev, bDurGrain), interp:inpol,
					pan:WhiteNoise.kr(paner),
					amp:amp2
				);

				grains_1 = TGrains.ar(2, Dust.ar(density), //grains 3
					bufNum2,
					WhiteNoise.ar(rateDev,rate.linexp(0.0, 1.0, 0.1, WhiteNoise.kr(0.5,4.0))),
					center,
					WhiteNoise.ar(durDev, durGrain),
					interp:inpol,
					pan:WhiteNoise.kr(paner),
					amp:amp3
				);

				b_grains2 = TGrains.ar(2, Dust.ar(bDensity), //grains 4
					bBufNum2,
					WhiteNoise.ar(bRateDev, bRate.linexp(0.0, 1.0, 0.1, WhiteNoise.kr(0.5,4.0))),
					center,
					WhiteNoise.ar(durDev, bDurGrain),
					interp:inpol,
					pan: WhiteNoise.kr(paner),
					amp:amp4
				);

				fft_A = FFT(LocalBuf(2048), grains);
				fft_B = FFT(LocalBuf(2048), b_grains);
				fft_A1 = FFT(LocalBuf(2048), grains_1);
				fft_B2 = FFT(LocalBuf(2048), b_grains2);
				morph = PV_Morph(fft_A, fft_B, xMorph); //morphing effect
				b_morph = PV_Morph(fft_A1, fft_B2, yMorph);
				Out.ar(outLeft, IFFT(morph), 0.6);
				Out.ar(outRight, IFFT(b_morph),  0.6);
		}).add;

		s.sync;
		~synth=Synth.new("inst", [bufNum: ~sounds[0], bBufNum: ~sounds[1], bufNum2: ~sounds[2], bBufNum2: ~sounds[3] ]);

		//Controls: Wiimote (changing sounds)
		~wiiButton_Buf1 =
		OSCresponderNode(nil,'/wii/1/button/B', {arg t, r, msg;
			if(msg[1]==1){
				~bufferPointer = ~bufferPointer + 1 % ~sounds.size;
				~synth.set(\bufNum, ~sounds[~bufferPointer]);
			};
			msg.postln;
		}).add;

		~wiiButton_Buf2 =
		OSCresponderNode(nil,'/wii/1/button/A', {arg t, r, msg;
			if(msg[1]==1){
				~bufferPointer = ~bufferPointer + 1 % ~sounds.size;
				~synth.set(\bufNum2, ~sounds[~bufferPointer]);
			};
			msg.postln;
		}).add;


		~wiiButton_Buf3 =
		OSCresponderNode(nil,'/wii/1/nunchuk/button/Z', {arg t, r, msg;
			if(msg[1]==1){
				~bufferPointer = ~bufferPointer + 1 % ~sounds.size;
				~synth.set(\bBufNum, ~sounds[~bufferPointer]);
			};
			msg.postln;
		}).add;

		~wiiButton_Buf4 =
		OSCresponderNode(nil,'/wii/1/nunchuk/button/C', {arg t, r, msg;
			if(msg[1]==1){
				~bufferPointer = ~bufferPointer + 1 % ~sounds.size;
				~synth.set(\bBufNum2, ~sounds[~bufferPointer]);
			};
			msg.postln;
		}).add;

		~wiiButton_Play //start synth
		= OSCresponderNode(nil,'/wii/1/button/Plus', {arg t, r, msg;
			if(msg[1]==1){ ~synth.run(true);
			};
			msg.postln;
		}).add;

		~wiiButton_Pause //stop synth
		= OSCresponderNode(nil,'/wii/1/button/Minus', {arg t, r, msg;
			if(msg[1]==1){
				~synth.run(false);
			};
			msg.postln;
		}).add;

	}.fork(AppClock);
})
)
