s.waitForBoot({
	{
//o = NetAddr("127.0.0.1", 57120);
t = TempoClock().permanent_(true);
t.tempo=1;
NdefMixer.new(s);

b = Buffer.alloc(s, 44100 *2, 1);
b.sine1( 1.0 / [1.0, 1.0, 1.0], true, true, true);

OSCdef(\in_wiiRoll, {|msg| ~roll = msg[1];
	Ndef(\granular).set(\dur, ~roll.linlin(0,1, 0.1, 9.3));
	Ndef(\granular).set(\ifreq, ~roll.linlin(0,1, 1, 30).asInteger);
	Ndef(\granular).set(\rate, ~roll.linexp(0,1, 0.01, 0.08));
	Ndef(\pitch).set(\rate, ~roll.linexp(0, 1, 0.1, 1.0));
}, '/wii/1/accel/pry/1');

OSCdef(\wii_pitch, {|msg|
	~pitch = msg[1];
	Ndef(\granular).set(\rateDev, ~pitch.linlin(0,1, 0.01, 1.1));
	Ndef(\pitch).set(\rDev, ~pitch.linlin(0,1, 0.1, 0.5));
	Ndef(\pitch).set(\tDev, ~pitch.linlin(0,1, 0.01, 0.3));
}, '/wii/1/accel/pry/0');

OSCdef(\wii_accel, {|msg|
	~accel = msg[1];
	Ndef(\granular).set(\ifreqDev, ~accel.linlin(0, 1, 0.01, 0.1));
	Ndef(\comb).set(\chaos, ~accel.linlin(0,1, 0.3, 0.6));
	Ndef(\pitch).set(\speed, ~accel.linlin(0, 1, 0.06, 10.0));
	Ndef(\granular).set(\centerPosDev, ~accel.linlin(0.3, 1, 0.01, 1.0));
	Ndef(\pitch).set(\speedDev, ~accel.linlin(0,1, 0.01, 2.0));
	Ndef(\phaseShift).set(\phaseShifter, ~accel.linlin(0,1, 0.01, 0.2));
},'/wii/1/accel/pry');

Ndef(\comb, {
	Limiter.ar(
		BufCombC.ar(b.bufnum,
			Crackle.ar(\chaos.kr(0.3).lag(0.3)),
		LFNoise1.kr(10).range(0.001, 0.2),
		LFNoise1.kr(10).range(0.001, 0.2));
	);
});

Spec.add(\chaos, [0.3, 1.5]);
Ndef(\comb).fadeTime=2.0;
Ndef(\comb).play(0, 2, vol: 0.0);

Ndef(\granular, {|dur=0.1, durDev=0.0, speed=10.0, rate=1.0, rateDev=0.1, centerPos=1.0, centerPosDev=0, pan=0.0, panDev=0.0, amp=1.0, ampDev=0.0, bufnum,
	overlap= 4, lagTime=2|
	var trigger = Impulse.kr(\ifreq.kr(1));
	Limiter.ar(HPF.ar(
		TGrains.ar(2, trigger, bufnum,
			WhiteNoise.ar(rateDev, rate.lag(0.3)),
			WhiteNoise.ar(centerPosDev, centerPos),
			WhiteNoise.ar(durDev, dur/lag(0.3)),
			WhiteNoise.ar(panDev, pan),
			WhiteNoise.ar(ampDev, amp), 4), 80, 0.6);
	);
});

Ndef(\granular).fadeTime = 0.2;
Ndef(\granular).set(\lagTime, 0.5);
Ndef(\granular).set(\bufnum, b.bufnum);
Ndef(\granular).play(0, 2, vol:0.3);

Ndef(\granular)[1] = \filter -> {|in| in * SinOsc.ar(Rand(100,1800));};

Ndef(\phaseShift, {|phaseShifter=1|
        var in, chain;
	    in = BPF.ar(Ndef(\granular).ar);
        chain = FFT(LocalBuf(2048), in);
	        chain = PV_PhaseShift(chain, phaseShifter.lag(0.3));
        IFFT(chain).dup;
});
Ndef(\phaseShift).play(0, 2, vol:0);
Ndef(\phaseShift).fadeTime=2;
Ndef(\phaseShift).clock = t;

Ndef(\pitch, {
	var sig = PitchShift.ar(HPF.ar(Ndef(\granular).ar, 50), 0.02, \rate.kr(2).lag(0.3), \rDev.kr(1.5).lag(0.3), \tDev.kr(0.5) );
	Limiter.ar(Compander.ar(sig, Ndef(\pitch).ar, thresh:0.5,slopeBelow:1, slopeAbove:1, clampTime:0.01, relaxTime:0.1))
	* SinOsc.ar(WhiteNoise.ar(\speedDev.kr(0.1), \speed.kr(0.7)));
});

Ndef(\pitch).fadeTime=0.5;
Ndef(\pitch).play(0, 2, vol:0);

Ndef(\add, { |freeze=0.2, freezDev=0.1, amp=1|
	var inA, chainA, chain;
	var pan = LFNoise1.kr(1).range(-1, 1);
	inA = Ndef(\bufRead).ar;
	chainA = FFT(LocalBuf(2048), inA);
	chain = PV_MagFreeze(chainA, SinOsc.ar(0.2) );
	Limiter.ar(Pan2.ar(IFFT(chain).dup, pan, amp) );
});
Ndef(\add).fadeTime=2;
Ndef(\add).clock = t;
Ndef(\add).play(0, 2, vol:0);

	}.fork(AppClock);
});

////////////////// The End ////////////////////

//Ndef.clear(8);
