
~sounds = SoundFile.collectIntoBuffers("~/Sounds/*", s); //a folder for samples


(
t = TempoClock.default; // define tempo

t.tempo=0.1; //change tempo
)
(
SynthDef(\glitch, {|out=0, rate=1, gate=1, buf, startPos=0, mix=0.0, room=0.0, maxdel=0.0, deltime=0.0, decay=0.0, amp=0.1|
	var sig, pan, del;
	pan = LFNoise1.kr(1).range(-1, 1);
sig = FreeVerb.ar(
		PlayBuf.ar(buf.numChannels, buf, BufRateScale.kr(buf) * rate, startPos:startPos, loop:0, doneAction:2),
		mix, room);
	del = CombC.ar(sig, maxdel, deltime, decay, 1, sig);
	Out.ar(out,
		Rotate2.ar(sig, del, pan)
	) * amp * EnvGate(1, gate);
}).add; //a synth to play samples
)

//patterns to play them
~sounds
(
Pdef(\x,
	Pbind(\instrument, \glitch,
		\dur, Prand([1/2, 4/4, 4/8, 4/16, 4/32], inf),
		\amp, 0.1,
		\rate, Pwhite(0.1, 1.0),
		\startPos, Pwhite(0.1, 1.0),
		\buf, ~sounds[6],
		\gate, Prand([0,1], inf),
		\mix, 4,
		\room, 6,
		\deltime, 0.1,
		\decay, 0.01
	);
);
)
Pdef([\x, \y]).quant(1);

(
Pdef(\y,
	Pbind(\instrument, \glitch,
		\dur, Prand([1/2, 4/4, 4/8, 4/16, 4/32], inf),
		\buf, ~sounds[4],
		\amp, 1.0,
		\rate, Pwhite(0.1, 1.0),
		\startPos, Pwhite(0.1, 1.0),
		\room, 3,
		\mix, 1,
		\deltime, 0.1,
		\decay, 0.1
	);
);
)


Pdef(\x).play(t);
Pdef(\x).stop;

Pdef(\y).play(t);
Pdef(\y).stop;